

<!DOCTYPE html>

<html lang="en">
  <head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>7.15.1. between &#8212; Groonga v10.1.1-31-g1e46ba6 documentation</title>
    <link rel="stylesheet" href="../../_static/groonga.css" type="text/css" />
    <link rel="stylesheet" href="../../_static/pygments.css" type="text/css" />
    
    <script id="documentation_options" data-url_root="../../" src="../../_static/documentation_options.js"></script>
    <script src="../../_static/jquery.js"></script>
    <script src="../../_static/underscore.js"></script>
    <script src="../../_static/doctools.js"></script>
    <script src="../../_static/language_data.js"></script>
    
    <link rel="shortcut icon" href="../../_static/favicon.ico"/>
    <link rel="index" title="Index" href="../../genindex.html" />
    <link rel="search" title="Search" href="../../search.html" />
    <link rel="next" title="7.15.2. cast_loose" href="cast_loose.html" />
    <link rel="prev" title="7.15. Function" href="../function.html" /> 
  </head><body>
<div class="header">
  <h1 class="title">
    <a id="top-link" href="../../index.html">
      <span class="project">groonga</span>
      <span class="separator">-</span>
      <span class="description">An open-source fulltext search engine and column store.</span>
    </a>
  </h1>

  <div class="other-language-links">
    <ul>
      <li><a href="../../../../ja/html/reference/functions/between.html">日本語</a></li>
    </ul>
  </div>
</div>
  

    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../../genindex.html" title="General Index"
             accesskey="I">index</a></li>
        <li class="right" >
          <a href="cast_loose.html" title="7.15.2. cast_loose"
             accesskey="N">next</a> |</li>
        <li class="right" >
          <a href="../function.html" title="7.15. Function"
             accesskey="P">previous</a> |</li>
        <li class="nav-item nav-item-0"><a href="../../index.html">Groonga v10.1.1-31-g1e46ba6 documentation</a> &#187;</li>
          <li class="nav-item nav-item-1"><a href="../../reference.html" ><span class="section-number">7. </span>Reference manual</a> &#187;</li>
          <li class="nav-item nav-item-2"><a href="../function.html" accesskey="U"><span class="section-number">7.15. </span>Function</a> &#187;</li>
        <li class="nav-item nav-item-this"><a href=""><span class="section-number">7.15.1. </span><code class="docutils literal notranslate"><span class="pre">between</span></code></a></li> 
      </ul>
    </div>  

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body" role="main">
            
  <div class="section" id="between">
<h1><span class="section-number">7.15.1. </span><code class="docutils literal notranslate"><span class="pre">between</span></code><a class="headerlink" href="#between" title="Permalink to this headline">¶</a></h1>
<div class="section" id="summary">
<h2><span class="section-number">7.15.1.1. </span>Summary<a class="headerlink" href="#summary" title="Permalink to this headline">¶</a></h2>
<p><code class="docutils literal notranslate"><span class="pre">between</span></code> is used for checking the specified value exists in the specific range.
It is often used in combination with <a class="reference internal" href="../commands/select.html#select-filter"><span class="std std-ref">filter</span></a> option in <a class="reference internal" href="../commands/select.html"><span class="doc">select</span></a>.</p>
</div>
<div class="section" id="syntax">
<h2><span class="section-number">7.15.1.2. </span>Syntax<a class="headerlink" href="#syntax" title="Permalink to this headline">¶</a></h2>
<p><code class="docutils literal notranslate"><span class="pre">between</span></code> has three or five parameters:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>between(column_or_value, min, max)
between(column_or_value, min, min_border, max, max_border)
</pre></div>
</div>
</div>
<div class="section" id="usage">
<h2><span class="section-number">7.15.1.3. </span>Usage<a class="headerlink" href="#usage" title="Permalink to this headline">¶</a></h2>
<p>Here are a schema definition and sample data to show usage.</p>
<p>Execution example:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>table_create Users TABLE_HASH_KEY ShortText
# [[0, 1337566253.89858, 0.000355720520019531], true]
column_create Users age COLUMN_SCALAR Int32
# [[0, 1337566253.89858, 0.000355720520019531], true]
table_create Ages TABLE_HASH_KEY Int32
# [[0, 1337566253.89858, 0.000355720520019531], true]
column_create Ages user_age COLUMN_INDEX Users age
# [[0, 1337566253.89858, 0.000355720520019531], true]
load --table Users
[
{&quot;_key&quot;: &quot;Alice&quot;,  &quot;age&quot;: 12},
{&quot;_key&quot;: &quot;Bob&quot;,    &quot;age&quot;: 13},
{&quot;_key&quot;: &quot;Calros&quot;, &quot;age&quot;: 15},
{&quot;_key&quot;: &quot;Dave&quot;,   &quot;age&quot;: 16},
{&quot;_key&quot;: &quot;Eric&quot;,   &quot;age&quot;: 20},
{&quot;_key&quot;: &quot;Frank&quot;,  &quot;age&quot;: 21}
]
# [[0, 1337566253.89858, 0.000355720520019531], 6]
</pre></div>
</div>
<p>Here is a query to show users who match PG-13 rating (MPAA).</p>
<p>Execution example:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>select Users --filter &#39;between(age, 13, &quot;include&quot;, 16, &quot;include&quot;)&#39;
# [
#   [
#     0,
#     1337566253.89858,
#     0.000355720520019531
#   ],
#   [
#     [
#       [
#         3
#       ],
#       [
#         [
#           &quot;_id&quot;,
#           &quot;UInt32&quot;
#         ],
#         [
#           &quot;_key&quot;,
#           &quot;ShortText&quot;
#         ],
#         [
#           &quot;age&quot;,
#           &quot;Int32&quot;
#         ]
#       ],
#       [
#         2,
#         &quot;Bob&quot;,
#         13
#       ],
#       [
#         3,
#         &quot;Calros&quot;,
#         15
#       ],
#       [
#         4,
#         &quot;Dave&quot;,
#         16
#       ]
#     ]
#   ]
# ]
</pre></div>
</div>
<p>It returns 13, 14, 15 and 16 years old users.</p>
<p><code class="docutils literal notranslate"><span class="pre">between</span></code> function accepts not only a column but also a value.</p>
<p>If you specify a value as the 1st parameter, it checks whether the value is included or not. If the value matches the specified range, the <code class="docutils literal notranslate"><span class="pre">select</span></code> returns all the records because the <code class="docutils literal notranslate"><span class="pre">between</span></code> function returns true.
If it doesn’t match the specified range, the <code class="docutils literal notranslate"><span class="pre">select</span></code> returns no records because the <code class="docutils literal notranslate"><span class="pre">between</span></code> function returns false.</p>
<p>Execution example:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>select Users --filter &#39;between(14, 13, &quot;include&quot;, 16, &quot;include&quot;)&#39;
</pre></div>
</div>
<p>In the above case, it returns all the records because 14 exists in between 13 and 16.
This behavior is used for checking the specified value exists or not in the table.</p>
</div>
<div class="section" id="parameters">
<h2><span class="section-number">7.15.1.4. </span>Parameters<a class="headerlink" href="#parameters" title="Permalink to this headline">¶</a></h2>
<div class="section" id="required-parameters">
<h3><span class="section-number">7.15.1.4.1. </span>Required parameters<a class="headerlink" href="#required-parameters" title="Permalink to this headline">¶</a></h3>
<p>There are three required parameters <code class="docutils literal notranslate"><span class="pre">column_or_value</span></code>, <code class="docutils literal notranslate"><span class="pre">min</span></code> and <code class="docutils literal notranslate"><span class="pre">max</span></code>.</p>
<div class="section" id="column-or-value">
<h4><span class="section-number">7.15.1.4.1.1. </span><code class="docutils literal notranslate"><span class="pre">column_or_value</span></code><a class="headerlink" href="#column-or-value" title="Permalink to this headline">¶</a></h4>
<p>Specifies a column or value.</p>
</div>
<div class="section" id="min">
<h4><span class="section-number">7.15.1.4.1.2. </span><code class="docutils literal notranslate"><span class="pre">min</span></code><a class="headerlink" href="#min" title="Permalink to this headline">¶</a></h4>
<p>Specifies the minimal border value of the range.
The range is inclusive by default but you can control the behavior that the value of <code class="docutils literal notranslate"><span class="pre">min</span></code> is included or excluded with <code class="docutils literal notranslate"><span class="pre">min_border</span></code> parameter.</p>
</div>
<div class="section" id="max">
<h4><span class="section-number">7.15.1.4.1.3. </span><code class="docutils literal notranslate"><span class="pre">max</span></code><a class="headerlink" href="#max" title="Permalink to this headline">¶</a></h4>
<p>Specifies the maximum border value of the range.
The range is inclusive by default but you can control the behavior that the value of <code class="docutils literal notranslate"><span class="pre">max</span></code> is included or excluded with <code class="docutils literal notranslate"><span class="pre">max_border</span></code> parameter.</p>
</div>
</div>
<div class="section" id="optional-parameter">
<h3><span class="section-number">7.15.1.4.2. </span>Optional parameter<a class="headerlink" href="#optional-parameter" title="Permalink to this headline">¶</a></h3>
<p>There are two optional parameters <code class="docutils literal notranslate"><span class="pre">min_border</span></code> and <code class="docutils literal notranslate"><span class="pre">max_border</span></code>.</p>
<div class="section" id="min-border">
<h4><span class="section-number">7.15.1.4.2.1. </span><code class="docutils literal notranslate"><span class="pre">min_border</span></code><a class="headerlink" href="#min-border" title="Permalink to this headline">¶</a></h4>
<p>Specifies whether the specified range contains the value of <code class="docutils literal notranslate"><span class="pre">min</span></code> or not.
The value of <code class="docutils literal notranslate"><span class="pre">min_border</span></code> must be either “include” or “exclude”. If it is “include”, <code class="docutils literal notranslate"><span class="pre">min</span></code> value is included. If it is “exclude”, <code class="docutils literal notranslate"><span class="pre">min</span></code> value is not included.</p>
</div>
<div class="section" id="max-border">
<h4><span class="section-number">7.15.1.4.2.2. </span><code class="docutils literal notranslate"><span class="pre">max_border</span></code><a class="headerlink" href="#max-border" title="Permalink to this headline">¶</a></h4>
<p>Specifies whether the specified range contains the value of <code class="docutils literal notranslate"><span class="pre">max</span></code> or not.
The value of <code class="docutils literal notranslate"><span class="pre">max_border</span></code> must be either “include” or “exclude”. If it is “include”, <code class="docutils literal notranslate"><span class="pre">max</span></code> value is included. If it is “exclude”, <code class="docutils literal notranslate"><span class="pre">max</span></code> value is not included.</p>
</div>
<div class="section" id="return-value">
<h4><span class="section-number">7.15.1.4.2.3. </span>Return value<a class="headerlink" href="#return-value" title="Permalink to this headline">¶</a></h4>
<p><code class="docutils literal notranslate"><span class="pre">between</span></code> returns whether the column value exists in the specified range or not. If a record matches the specified range, it returns true. Otherwise, it returns false.</p>
</div>
</div>
</div>
</div>


            <div class="clearer"></div>
          </div>
        </div>
      </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
  <h3><a href="../../index.html">Table of Contents</a></h3>
  <ul>
<li><a class="reference internal" href="#">7.15.1. <code class="docutils literal notranslate"><span class="pre">between</span></code></a><ul>
<li><a class="reference internal" href="#summary">7.15.1.1. Summary</a></li>
<li><a class="reference internal" href="#syntax">7.15.1.2. Syntax</a></li>
<li><a class="reference internal" href="#usage">7.15.1.3. Usage</a></li>
<li><a class="reference internal" href="#parameters">7.15.1.4. Parameters</a><ul>
<li><a class="reference internal" href="#required-parameters">7.15.1.4.1. Required parameters</a><ul>
<li><a class="reference internal" href="#column-or-value">7.15.1.4.1.1. <code class="docutils literal notranslate"><span class="pre">column_or_value</span></code></a></li>
<li><a class="reference internal" href="#min">7.15.1.4.1.2. <code class="docutils literal notranslate"><span class="pre">min</span></code></a></li>
<li><a class="reference internal" href="#max">7.15.1.4.1.3. <code class="docutils literal notranslate"><span class="pre">max</span></code></a></li>
</ul>
</li>
<li><a class="reference internal" href="#optional-parameter">7.15.1.4.2. Optional parameter</a><ul>
<li><a class="reference internal" href="#min-border">7.15.1.4.2.1. <code class="docutils literal notranslate"><span class="pre">min_border</span></code></a></li>
<li><a class="reference internal" href="#max-border">7.15.1.4.2.2. <code class="docutils literal notranslate"><span class="pre">max_border</span></code></a></li>
<li><a class="reference internal" href="#return-value">7.15.1.4.2.3. Return value</a></li>
</ul>
</li>
</ul>
</li>
</ul>
</li>
</ul>

  <h4>Previous topic</h4>
  <p class="topless"><a href="../function.html"
                        title="previous chapter"><span class="section-number">7.15. </span>Function</a></p>
  <h4>Next topic</h4>
  <p class="topless"><a href="cast_loose.html"
                        title="next chapter"><span class="section-number">7.15.2. </span><code class="docutils literal notranslate"><span class="pre">cast_loose</span></code></a></p>
<div id="searchbox" style="display: none" role="search">
  <h3 id="searchlabel">Quick search</h3>
    <div class="searchformwrapper">
    <form class="search" action="../../search.html" method="get">
      <input type="text" name="q" aria-labelledby="searchlabel" />
      <input type="submit" value="Go" />
    </form>
    </div>
</div>
<script>$('#searchbox').show(0);</script>
        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../../genindex.html" title="General Index"
             >index</a></li>
        <li class="right" >
          <a href="cast_loose.html" title="7.15.2. cast_loose"
             >next</a> |</li>
        <li class="right" >
          <a href="../function.html" title="7.15. Function"
             >previous</a> |</li>
        <li class="nav-item nav-item-0"><a href="../../index.html">Groonga v10.1.1-31-g1e46ba6 documentation</a> &#187;</li>
          <li class="nav-item nav-item-1"><a href="../../reference.html" ><span class="section-number">7. </span>Reference manual</a> &#187;</li>
          <li class="nav-item nav-item-2"><a href="../function.html" ><span class="section-number">7.15. </span>Function</a> &#187;</li>
        <li class="nav-item nav-item-this"><a href=""><span class="section-number">7.15.1. </span><code class="docutils literal notranslate"><span class="pre">between</span></code></a></li> 
      </ul>
    </div>
    <div class="footer" role="contentinfo">
        &#169; Copyright 2009-2021, Brazil, Inc.
    </div>
  </body>
</html>